function listf = listfiles(lsargs)
%
% simply call unix ls to get a list of files
% the output is converted in matlab cells for simplicity
%
% the arg is a string that must exactly correspond a options of 'ls'
% type "man ls" in the shell.
%
% Exemples :
% listfiles('/some/path/')
% listfiles('/some/path/wa_*.img') 
% listfiles('/some/path/[0-9][0-9][0-9].img')   
% listfiles('-d /some/path/[0-9][0-9][0-9].img')  
% Brice Fernandez - March 2011
%

if( ischar(lsargs) ~= 1) 
    error('arg 1 should be a string /path/to/file/i*');    
end

if( isunix == 1 )
    
    [status, list] = unix(['ls -1 ' lsargs]);
    
    if(status == 0)
        idx_empty = find( isspace(list) == 1 );
        
        listf = cell(1,1);
        
        idx=1;
        listf{idx} = deblank(list(1:idx_empty(1)));
        
        idx=idx+1;
        
        for k = 1 : length(idx_empty)-1,
            if( isempty(deblank(list(idx_empty(k)+1:idx_empty(k+1)))) ~= 1 )
                
                listf{idx} = deblank(list(idx_empty(k)+1:idx_empty(k+1)));
                idx = idx +1;
            end
        end
    else
        % else error display output from the system        
        error(list);
    end
    
elseif( ispc == 1)
    warning('this funtion has not been tested on winows. Let''s try '); 
    warning('please send me (Brice) the results ');    
    
    list = ls(lsargs); 
    
    [m, n] = size(list); 
    
    listf = cell(m,1);
    for k = 1 : m, 
        listf{k} = deblank(list(k,:)); 
    end
    
else
    error('This function does not works on your platform')
end

